<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/mode_string_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/14/84  mode_string_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The mode_string_subroutine provides a set of entry points for handling
<span id="L4" class="LineNr">  4 </span>mode strings.  Mode strings are a way for a user to pass control
<span id="L5" class="LineNr">  5 </span>information to a command or subsystem.  A mode string is a character
<span id="L6" class="LineNr">  6 </span>string which contains one or more modes, or is empty.  A mode is a
<span id="L7" class="LineNr">  7 </span>character string, separated from other modes by a comma.
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>The mode_string_ entries describe a mode string with the data
<span id="L10" class="LineNr"> 10 </span>structures declared in mode_string_info.incl.pl1.  See the
<span id="L11" class="LineNr"> 11 </span>Subroutines manual <span class="textRainbow_lv0_p0">(</span>AG93<span class="textRainbow_lv0_p0">)</span> for more information.
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Entry points in mode_string_:
<span id="L15" class="LineNr"> 15 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>:Entry:  combine:  02/14/84 mode_string_$combine
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Function: returns a mode string which represents the union of the
<span id="L22" class="LineNr"> 22 </span>modes defined in the two input arguments.  The order of modes in the
<span id="L23" class="LineNr"> 23 </span>output string is not defined.  If the same parameter is given in both
<span id="L24" class="LineNr"> 24 </span>structures, the type and value are taken from the second structure.
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Syntax:
<span id="L28" class="LineNr"> 28 </span>declare mode_string_$combine entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L29" class="LineNr"> 29 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L30" class="LineNr"> 30 </span>call mode_string_$combine <span class="textRainbow_lv0_p0">(</span>mode_string_info_ptr1<span class="textRainbow_lv0_o0">,</span>
<span id="L31" class="LineNr"> 31 </span>     mode_string_info_ptr2<span class="textRainbow_lv0_o0">,</span> modestr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>Arguments:
<span id="L35" class="LineNr"> 35 </span>mode_string_info_ptr1
<span id="L36" class="LineNr"> 36 </span>   points to the first mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr"> 37 </span>mode_string_info_ptr2
<span id="L38" class="LineNr"> 38 </span>   points to the second mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This
<span id="L39" class="LineNr"> 39 </span>   pointer may be null, and the string is formed from the first
<span id="L40" class="LineNr"> 40 </span>   structure only.
<span id="L41" class="LineNr"> 41 </span>modestr
<span id="L42" class="LineNr"> 42 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr"> 43 </span>code
<span id="L44" class="LineNr"> 44 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>:Entry:  delete:  02/14/84 mode_string_$delete
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>Function: returns a new mode string, with any mention of specified
<span id="L51" class="LineNr"> 51 </span>modes deleted.  It is not an error if any of the specified modes are
<span id="L52" class="LineNr"> 52 </span>absent from the structure.
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>Syntax:
<span id="L56" class="LineNr"> 56 </span>declare mode_string_$delete entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L57" class="LineNr"> 57 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L58" class="LineNr"> 58 </span>call mode_string_$delete <span class="textRainbow_lv0_p0">(</span>mode_string_info_ptr<span class="textRainbow_lv0_o0">,</span> excludes<span class="textRainbow_lv0_o0">,</span> modestr<span class="textRainbow_lv0_o0">,</span>
<span id="L59" class="LineNr"> 59 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>Arguments:
<span id="L63" class="LineNr"> 63 </span>mode_string_info_ptr
<span id="L64" class="LineNr"> 64 </span>   is a pointer to the mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L65" class="LineNr"> 65 </span>excludes
<span id="L66" class="LineNr"> 66 </span>   is the array of names to be excluded.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> To exclude a single
<span id="L67" class="LineNr"> 67 </span>   name, a scalar may be given.
<span id="L68" class="LineNr"> 68 </span>modestr
<span id="L69" class="LineNr"> 69 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L70" class="LineNr"> 70 </span>code
<span id="L71" class="LineNr"> 71 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>:Entry:  get:  02/14/84 mode_string_$get
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>Function: returns a mode string formed from the mode string info
<span id="L78" class="LineNr"> 78 </span>structure supplied it.  If the caller supplied string is not long
<span id="L79" class="LineNr"> 79 </span>enough to hold the mode string, it is truncated at the nearest whole
<span id="L80" class="LineNr"> 80 </span>mode, and the error code error_table_$mode_string_truncated is
<span id="L81" class="LineNr"> 81 </span>returned.  This ensures that the mode string returned is valid.
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Syntax:
<span id="L85" class="LineNr"> 85 </span>declare mode_string_$get entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L86" class="LineNr"> 86 </span>call mode_string_$get <span class="textRainbow_lv0_p0">(</span>mode_string_info_ptr<span class="textRainbow_lv0_o0">,</span> modestr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>Arguments:
<span id="L90" class="LineNr"> 90 </span>mode_string_info_ptr
<span id="L91" class="LineNr"> 91 </span>   is a pointer to the mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L92" class="LineNr"> 92 </span>modestr
<span id="L93" class="LineNr"> 93 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L94" class="LineNr"> 94 </span>code
<span id="L95" class="LineNr"> 95 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>:Entry:  get_error:  02/14/84 mode_string_$get_error
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>Function: returns a mode string built from an info structure.  Only
<span id="L102" class="LineNr">102 </span>the modes whose values have nonzero error codes are returned.  This
<span id="L103" class="LineNr">103 </span>selection mechanism can be used to return a list of bad modes when a
<span id="L104" class="LineNr">104 </span>call to iox_$modes fails, for inclusion in an error message.
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>Syntax:
<span id="L108" class="LineNr">108 </span>declare mode_string_$get_error entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L109" class="LineNr">109 </span>call mode_string_$get_error <span class="textRainbow_lv0_p0">(</span>mode_string_info_ptr<span class="textRainbow_lv0_o0">,</span> modestr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>Arguments:
<span id="L113" class="LineNr">113 </span>mode_string_info_ptr
<span id="L114" class="LineNr">114 </span>   is a pointer to the mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>modestr
<span id="L116" class="LineNr">116 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L117" class="LineNr">117 </span>code
<span id="L118" class="LineNr">118 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>:Entry:  get_mode:  02/14/84 mode_string_$get_mode
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>Function: parses a supplied mode string and extracts a single
<span id="L125" class="LineNr">125 </span>parameter from it, filling in a caller-supplied mode_value structure
<span id="L126" class="LineNr">126 </span><span class="textRainbow_lv0_p0">(</span>remember to set the version<span class="textRainbow_lv0_p0">)</span>, or returning an error code if the
<span id="L127" class="LineNr">127 </span>parameter is not present in the string.
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>Syntax:
<span id="L131" class="LineNr">131 </span>declare mode_string_$get_mode <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L132" class="LineNr">132 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L133" class="LineNr">133 </span>call mode_string_$get_mode <span class="textRainbow_lv0_p0">(</span>modestr<span class="textRainbow_lv0_o0">,</span> mode_name<span class="textRainbow_lv0_o0">,</span> mode_value_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>Arguments:
<span id="L137" class="LineNr">137 </span>modestr
<span id="L138" class="LineNr">138 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L139" class="LineNr">139 </span>mode_name
<span id="L140" class="LineNr">140 </span>   is the name of the mode to search for.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L141" class="LineNr">141 </span>mode_value_ptr
<span id="L142" class="LineNr">142 </span>   is a pointer to a mode_value structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L143" class="LineNr">143 </span>code
<span id="L144" class="LineNr">144 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>:Entry:  parse:  02/14/84 mode_string_$parse
<span id="L148" class="LineNr">148 </span>
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>Function: parses a mode string, allocating a structure giving the
<span id="L151" class="LineNr">151 </span>parameters specified in the string.
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>Syntax:
<span id="L155" class="LineNr">155 </span>declare mode_string_$parse entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L156" class="LineNr">156 </span>call mode_string_$parse <span class="textRainbow_lv0_p0">(</span>modestr<span class="textRainbow_lv0_o0">,</span> areap<span class="textRainbow_lv0_o0">,</span> mode_string_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>Arguments:
<span id="L160" class="LineNr">160 </span>modestr
<span id="L161" class="LineNr">161 </span>   is a mode string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L162" class="LineNr">162 </span>areap
<span id="L163" class="LineNr">163 </span>   points to an area where the mode string info structure may be
<span id="L164" class="LineNr">164 </span>   allocated.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If a null pointer is provided, the system area
<span id="L165" class="LineNr">165 </span>   is used.
<span id="L166" class="LineNr">166 </span>mode_string_info_ptr
<span id="L167" class="LineNr">167 </span>   is a pointer to the mode_string_info structure.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L168" class="LineNr">168 </span>code
<span id="L169" class="LineNr">169 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>  It can be:
<span id="L170" class="LineNr">170 </span>   error_table_$bad_mode_value
<span id="L171" class="LineNr">171 </span>      rejects modes for incorrect type.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
